--------------------------------------------------------------------------------
-- Storing meta-information
--------------------------------------------------------------------------------

{-# LANGUAGE DataKinds              #-}

module Auxiliary.Metadata where


import Auxiliary.Utils

--------------------------------------------------------------------------------
-- Universe
--------------------------------------------------------------------------------

-- Now using the new type-level lits
data MetaCons = MC { conName     :: Symbol
                   , conFixity   :: Fixity
                   , conIsRecord :: Bool }

data Fixity = Prefix | Infix Associativity Nat
  -- deriving (Eq, Show, Ord, Read)
{-
-- Interesting, now I can't define this...
prec :: Fixity -> Int
prec Prefix      = 10
prec (Infix _ n) = n
-}
data Associativity =  LeftAssociative 
                   |  RightAssociative
                   |  NotAssociative
  deriving (Eq, Show, Ord, Read)
{-
-- This class is no longer needed, as it's replaced by SingI
class Constructor (s :: Symbol) where
  conName :: Proxy s -> String
  -- ...
-}

data MetaData = MD { dataName :: Symbol, dataModule :: Symbol }

data MetaSel = MS { selName :: Maybe Symbol }
